// #autoload
// #name = EgoAmmo
// #version = 1.0
// #status = release
// #author = Ego
// #warrior = -Ego-
// #category = EgoScripts
// #description = includes info on grenades and health kit in a revised ammo hud - hudmover compatible
// #status = release
// #include = support/loadout.cs
// #include = support/callback.cs
// #credit = All credit goes to Monk and Fragbait i only combined their scripts into this one

if(!isObject(EgoAmmo))
{
	new ScriptObject(EgoAmmo)
	{
		class = EgoAmmo;
		
		hideInvHud = true;  // hide inventory hud always - set to false to display inventory hud
		hideWpnHud = true;  // hide weapons hud always - set to false to display weapons hud
	};
}

$EgoAmmo::pickupText["some grenades"] = "Grenade";
$EgoAmmo::pickupText["some flash grenades"] = "Whiteout Grenade";
$EgoAmmo::pickupText["some concussion grenades"] = "Concussion Grenade";
$EgoAmmo::pickupText["some flare grenades"] = "Flare Grenade";
$EgoAmmo::pickupText["a deployable camera"] = "Deployable Camera";

function EgoAmmo::ReSpawn(%this)
{

    $EgoAmmo::CurrentFavName = "-- Spawn --";
    $EgoAmmo::CurrentFav = "armor\tScout\tWeapon\tBlaster\tWeapon\tSpinfusor\tWeapon\tChaingun\tpack\tEMPTY\tGrenade\tGrenade\tMine\tEMPTY";
    $EgoAmmo::CurrentFavNum = -1;
    $EgoAmmo::currentGren = "Grenade";
    $EgoAmmo::PlayerDead = 0;

    EgoAmmo.RefreshSelected();
   
}

function EgoAmmo::FavChange(%this, %index)
{
    $EgoAmmo::SelectedFav = $pref::Favorite[$pref::FavCurrentSelect];
    $EgoAmmo::SelectedFavNum = $pref::FavCurrentSelect;
    $EgoAmmo::SelectedFavName = $pref::FavNames[$pref::FavCurrentSelect];

    for (%i = 0; %i < getFieldCount($EgoAmmo::SelectedFav); %i++) {
        %type = getField($EgoAmmo::SelectedFav, %i);
        %equipment = getField($EgoAmmo::SelectedFav, %i++);

        if(%type $= "Grenade") {
            $EgoAmmo::SelectedGren = %equipment;
        }
    }

}

function EgoAmmo::QuickChange(%this, %pack, %item)
{
    if ( !isObject($Hud['inventoryScreen'].staticData[1, 1])
          || $Hud['inventoryScreen'].staticData[1, 1].getValue() $= ""  ) {
        for (%i = 0; %i < getFieldCount($EgoAmmo::SelectedFav); %i++) {
            %type = getField($EgoAmmo::SelectedFav, %i);
            %equipment = getField($EgoAmmo::SelectedFav, %i++);

            %invalidPack = checkPackValidity(%pack, %equipment, %item );
            if(%invalidPack) {
                return;
            }
        }
    } else {
        %armor =  $Hud['inventoryScreen'].data[0, 1].getValue();
        %invalidPack = checkPackValidity(%pack, %armor, %item );
        if(%invalidPack) {
          return;
        }

        for (%i = 1; %i < $Hud['inventoryScreen'].count; %i++) {
            %type = $Hud['inventoryScreen'].data[%i, 1].type;
            %equipment = $Hud['inventoryScreen'].data[%i, 1].getValue();
  
            if(%type $= %item) {
                %equipment = %pack;
            }
  
            %invalidPack = checkPackValidity(%pack, %equipment, %item );
            if(%invalidPack) {
                return;
            }
        }
    }

    if(%item $= "Grenade") {
        $EgoAmmo::SelectedGren = %pack;
    }
}


function EgoAmmo::InvUsed(%this)
{
    $EgoAmmo::CurrentFavName = $pref::FavNames[$EgoAmmo::SelectedFavNum];
    $EgoAmmo::CurrentFav = $EgoAmmo::SelectedFav;
    $EgoAmmo::CurrentFavNum = $EgoAmmo::SelectedFavNum;
    $EgoAmmo::currentGren = $EgoAmmo::SelectedGren;

    }


function EgoAmmo::RefreshSelected(%this)
{
    $EgoAmmo::SelectedFav = $pref::Favorite[$pref::FavCurrentSelect];
    $EgoAmmo::SelectedFavNum = $pref::FavCurrentSelect;
    $EgoAmmo::SelectedFavName = $pref::FavNames[$pref::FavCurrentSelect];

    for (%i = 1; %i < $Hud['inventoryScreen'].count; %i++) {
        %type = $Hud['inventoryScreen'].data[%i, 1].type;
        %equipment = $Hud['inventoryScreen'].data[%i, 1].getValue();

        if(%type $= "Grenade") {
            $EgoAmmo::SelectedGren = %equipment;
        }
    }
}

function EgoAmmoPickedUp(%Msgtype, %msgtext, %itemtext)
{
    if($EgoAmmo::pickupText[%itemtext] !$= "") {
        $EgoAmmo::currentGren = $EgoAmmo::pickupText[%itemtext];
        
    }
}

package EgoAmmoPackage
{
	function DispatchLaunchMode()
	{
		parent::DispatchLaunchMode();
		callback.add(PlayerUseInv, "EgoAmmo.InvUsed();");
		addMessageCallback('MsgItemPickup', EgoAmmoPickedUp);		
		EgoAmmo.setup();
	}  // end function DispatchLaunchMode
	
	function LoadingGui::onWake(%this)
	{
		EgoAmmo.create();
		EgoAmmoHud.setVisible(true);
								
		if(isObject(HudMover))
			hudmover::addhud(EgoAmmoHud, "EgoAmmoHud");
					
		parent::onWake(%this);
	}  // end function LoadingGui::onWake
			
	// set up text profile

	function EgoAmmo::setup()
	{
		new GuiControlProfile("EgoAmmoHudProfile")
		{
			fontType = "arial bold";
			fontSize = 13;
			bitmap = "";
			fontColor = "0 0 0";
			justify = "center";
		};
	} // end function EgoAmmoSetup
	
	// handle ammo and inv updating
	
	function ammoHud::setValue(%slot, %amount)
	{
		parent::setValue(%slot, %amount);
		%ammoUpdate = "<color:ffffff>" @ %amount;
		$ammoUpdate = %ammoUpdate;
		EgoAmmoHudText.setText(%ammoUpdate@$kitUpdate);
	} // end function ammoHud::setValue

	// testing inventory functions
	
	function clientCmdSetInventoryHudAmount(%slot, %amount)
	{
		if(%slot == 0)
		{
			%grenades = %amount;
			if(EgoAmmoGetGrenType() $= "Grenade")
			%grenadeUpdate = "<color:804000>" @ %grenades;
			else if(EgoAmmoGetGrenType() $= "Whiteout Grenade")
			%grenadeUpdate = "<color:ffffff>" @ %grenades;
			else if(EgoAmmoGetGrenType() $= "Concussion Grenade")
			%grenadeUpdate = "<color:4040ff>" @ %grenades;
			else if(EgoAmmoGetGrenType() $= "Flare Grenade")
			%grenadeUpdate = "<color:ff0000>" @ %grenades;
			else if(EgoAmmoGetGrenType() $= "Deployable Camera")
			%grenadeUpdate = "<color:000000>" @ %grenades;
			else %grenadeUpdate = "<color:000000>" @ %grenades;
			if (%grenades $="0")
			%grenadeUpdate = "";
			$grenadeUpdate = %grenadeUpdate;
			EgoGrenHudText.setText(%grenadeUpdate@" "@$minesUpdate);
		}
		else if(%slot == 3)
		{
			%kit = %amount;
			if(%kit > 0)
				%kitUpdate = "<color:00ff00>+";
			else
				%kitUpdate = "<color:ff0000>-";
			$kitupdate = %kitUpdate;
			EgoAmmoHudText.setText($ammoUpdate@%kitUpdate);
			
		}
		else if(%slot == 1)
		{
			%mines = %amount;
			%minesUpdate = "<color:00ff00>" @ %amount;
			if (%amount $= "0")
			%minesUpdate = "";
			$minesUpdate = %minesUpdate;
			EgoGrenHudText.setText($grenadeUpdate@" "@%minesUpdate);
		}
		parent::clientCmdSetInventoryHudAmount(%slot, %amount);
	}
		
	// override functions to display the huds desired
	
	function ClientCmdDisplayHuds()
	{
		parent::ClientCmdDisplayHuds();
		ammoHud.setVisible(false);
		if(EgoAmmo.hideInvHud)
			inventoryHud.setVisible(false);
		if(EgoAmmo.hideWpnHud)
			weaponsHud.setVisible(false);	
	}
	
	function clientcmdTogglePlayHuds(%val)
	{
		parent::clientcmdTogglePlayHuds(%val);
		ammoHud.setVisible(false);
		if(EgoAmmo.hideInvHud)
			inventoryHud.setVisible(false);
		if(EgoAmmo.hideWpnHud)
			weaponsHud.setVisible(false);
	}

	function hudFirstPersonToggled()
	{
		parent::hudFirstPersonToggled();
		ammoHud.setVisible(false);
		if(EgoAmmo.hideInvHud)
			inventoryHud.setVisible(false);
		if(EgoAmmo.hideWpnHud)
			weaponsHud.setVisible(false);
	}
	
	function clientCmdSetWeaponsHudActive(%slot, %ret, %vis) {
		parent::clientCmdSetWeaponsHudActive(%slot, %ret, %vis);
		ammoHud.setVisible(0);
	}	
	
	// define, create and destroy the huds

	function EgoAmmo::create()
	{
		EgoAmmo.destroy();
		
		%xCenter = getword($pref::Video::resolution, 0) / 2;  // get screen center
		%x = %xCenter - 25;
		%y = 100;
		
		new ShellFieldCtrl("EgoAmmoHud")
		{
			profile = "GuiConsoleProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "68 393";  // should be able to use = %x SPC %y
			extent = "36 50";
			minExtent = "8 8";
			visible = "1";
					
			new GuiMLTextCtrl(EgoAmmoHudText)
			{
				profile = "EgoAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "3 3";
				extent = "33 12";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "1";
				allowColorChars = "1";
				maxChars = "-1";
			};
		
			new GuiMLTextCtrl(EgoGrenHudText)
			{
				profile = "EgoAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "3 16";
				extent = "33 12";
				minExtent = "8 8";
				visible = "0";
				helpTag = "0";
				lineSpacing = "1";
				allowColorChars = "1";
				maxChars = "-1";
			};
			
			new GuiMLTextCtrl(EgoKitHudText)
			{
				profile = "EgoAmmoHudProfile";
				horizSizing = "left";
				vertSizing = "bottom";
				position = "3 29";
				extent = "33 12";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				lineSpacing = "1";
				allowColorChars = "1";
				maxChars = "-1";
			};			
		
		};		
		
		playgui.add(EgoAmmoHud);
	} // end function EgoAmmo::create
	
	function EgoAmmo::destroy()
	{
		if(isObject(EgoAmmoHud))
		{
			playGui.remove(EgoAmmoHud);
			EgoAmmoHud.delete();
		}
	} // end function EgoAmmo::destroy
	
	function toggleCursorHuds(%val)
{
    parent::toggleCursorHuds(%val);
    if(%val $= 'inventoryScreen') {
        EgoAmmo.RefreshSelected();
    }
}

function loadFavorite(%index, %echo)
{
    parent::loadFavorite(%index, %echo);
    EgoAmmo.FavChange(%index);
}

function addQuickPackFavorite(%pack, %item)
{
    parent::addQuickPackFavorite(%pack, %item);
    EgoAmmo.QuickChange(%pack, %item);
}

function addQuickChangeFavorite(%pack, %item)
{
    parent::addQuickChangeFavorite(%pack, %item);
    EgoAmmo.QuickChange(%pack, %item);
}

function clientCmdSetInventoryHudItem(%slot, %amount, %addItem)
{
    parent::clientCmdSetInventoryHudItem(%slot, %amount, %addItem);
    EgoAmmo.ReSpawn();
}

function EgoAmmoGetGrenType() {
    return $EgoAmmo::currentGren;
}
}; // end package EgoAmmo
activatePackage(EgoAmmoPackage);
