// #name = KmaSpeedHud
// #version = 1.0
// #date = 25 March 2002
// #author = Kaiten Commander
// #credits = DogmeatX, His Idea!!
// #email = kaiten@cb-tribes.co.uk
// #web = http://www.clan-kma.com
// #description = Shows Speed,In a little Hud with Missile evade speed indicator.
// #status = beta

package KmaSpeedHud
{
	
function KmaSpeedHudUpdate()
{
	if ($KmaSpeedHudSchedule != 0) cancel($KmaSpeedHudSchedule);
	$KmaSpeed1 = mFloor(getControlObjectSpeed() * 3.6);
	$KmaSpeed2 = "400";
	KmaSpeedHudBar.value = $KmaSpeed1 / $KmaSpeed2;
	$KmaSpeedHudSchedule = schedule(500, 0, KmaSpeedHudupdate);

}

function KmaSpeedHudCreate()
{
	KmaSpeedHudDestroy();

	new ShellFieldCtrl(KmaSpeedHud) {
		profile = "GuiChatBackProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = getword($pref::Video::resolution, 0)-40 @ " " @ getword($pref::Video::resolution, 1)/3;
		extent = "303 18";
		minExtent = "303 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new HudBitmapCtrl()
		{
			profile = "GuiButtonProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			position = "0 0";
			extent = "131 10";
			opacity = "0.6";
			autoCenter = "0";
			minExtent = "131 10";
			bitmap = "gui/KmaSpeedHudImg";
			autoCenter = "0";
			autoResize = "0";
			flipVertical = "0";
			flipHorizontal = "0";		
			visible = "1";
		
			new HudBarBaseCtrl(KmaSpeedHudBar)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "8 1";
				extent = "125 15";
				minExtent = "125 15";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				fillColor = "0.000000 0.800000 0.000000 1.000000";
				frameColor = "0.000000 1.000000 0.000000 1.000000";
				opacity = "0.6";
				autoCenter = "0";
				autoResize = "0";
				flipVertical = "0";
				flipHorizontal = "0";
				subRegion = "2 2 116 4";
				displayMounted = "0";
				pulseRate = "500";
				pulseThreshold = "0.3";
				verticalFill = "0";
				value = "0.868807";
			};	
		};
	};

	playgui.add(KmaSpeedHud);

	if(isObject(HM) && isObject(HudMover))
		hudmover::addhud(KmaSpeedHud,"KmA Speed Hud");
}

function KmaSpeedHudDestroy()
{
	if ($KmaSpeedHud !$= "")
	{
		playgui.remove(KmaSpeedHud);
		KmaSpeedHud.delete();
		$KmaSpeedHud = "";
	}
}

function LoadingGui::onWake(%this)
{
	if (!$KmaSpeedHudsetup)
	{
		KmaSpeedHudCreate();
		KmaSpeedHudUpdate();
		$KmaSpeedHudSetup = true;
	}
	
	parent::onWake(%this);
}

function KmaSpeedHudToggle(%val)
{
    if (%val)
    {
        if($KmaSpeedToggle)
        {
		$KmaSpeedToggle = false;
		playgui.remove(KmaSpeedHud);
         }
         else
         {
		$KmaSpeedToggle = true;
		playgui.add(KmaSpeedHud);
        }
     }
}

function OptionsDlg::onWake( %this )
{
	if(!$KmaSpeedHudBind) {
        	$RemapName[$RemapCount]="KmA Speed Hud";
        	$RemapCmd[$RemapCount]="KmaSpeedHudToggle";
        	$RemapCount++;
         	$KmaSpeedHudBind = true;
   	}
   	parent::onWake( %this );
}

}; 
activatePackage(KmaSpeedHud);		
