// #autoload
// #name = Weapon Hud
// #version = 1.0
// #date = 29 Gen, 2003
// #author = onaaz
// #warrior = onaaz
// #email = leo@extrusivedesign.com
// #web = http://www.extrusivedesign.com
// #description = WeaponHud replacement
// #credit = Anakha, Da_Timsta
// #status = Finished
// #readme = none

if(!isObject(AnaWep))
{
	new scriptObject(AnaWep)
	{
		class = AnaWep;
		transparent = true;
		weaponGui = "AnaWepBitmap";
		ammoGui = "AnaWepAmmo";
		// user config
		removeWeaponsHud = true;
		removeAmmoHud = false;
		ammoFont = "arial bold";
		ammoSize = 12;
		ammoColor = "F0F0F0";
	};
}

function AnaWep::HandleAmmo(%this, %amount)
{
	if(%amount >= 0)
		%this.ammoGui.setText("<just:center><font:" @ %this.ammoFont @ ":" @ %this.ammoSize @ "><color:" @ %this.ammoColor @ ">" @ %amount);
	else
		%this.ammoGui.setText("");
}

package AnaWep
{
	function DispatchLaunchMode()
	{
		AnaWep.Create();
		parent::DispatchLaunchMode();
	}
	
	function clientCmdSetWeaponsHudActive(%slot, %ret, %vis)
   {
		parent::clientCmdSetWeaponsHudActive(%slot, %ret, %vis);
		if(%slot != -1)
			AnaWep.weaponGui.setBitmap("AnaWep/" @ strReplace(strReplace(strReplace($WeaponNames[%slot], "TR2", ""), "Gold", ""), "Silver", "") @ ".png");
	}
	
	function clientCmdSetAmmoHudCount(%amount)
	{
		parent::clientCmdSetAmmoHudCount(%amount);
		AnaWep.HandleAmmo(%amount);
	}
	
	function loadingGui::onWake(%this)
	{
		parent::onWake(%this);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(%this.weaponGui, "Anakha Weapon Hud");
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(%this.ammoGui, "Anakha Ammo Hud");
	}
};
activatePackage(AnaWep);

function AnaWep::Create(%this)
{
	new GuiBitmapCtrl(%this.weaponGui) 
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "976 63";
		extent = "15 15";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		wrap = "0";
		bitmap = "AnaWep/Disc.png";
	};
	new GuiMLTextCtrl(%this.ammoGui) 
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "100 0";
		extent = "50 50";
		minExtent = "8 8";
		visible = "0";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		lineSpacing = "2";
		allowColorChars = "0";
		maxChars = "-1";
		deniedSound = "InputDeniedSound";				
	};     
	playGui.add(%this.weaponGui);
	playGui.add(%this.ammoGui);
	
	if(%this.removeWeaponsHud) playGui.remove(weaponsHud);
	if(%this.removeAmmoHud) retCenterHud.remove(AmmoHud);	
}
