if(!isObject(Bars))
{
	new scriptObject(Bars)
	{
		class = Bars;
		damagex = 150;
		damagey = 6;
		energyx = 150;
		energyy = 6;
		heatx = 170;
		heaty = 9;
	};
}

package Bars
{
	function DispatchLaunchMode()
	{
		parent::DispatchLaunchMode();
	    Bars.Create();
	}
	
	function loadingGui::onWake(%this)
	{
		parent::onWake(%this);
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(DamageHud, "DamageHud");
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(EnergyHud, "EnergyHud");
		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(HeatHud, "HeatHud");
	}
};
activatePackage(Bars);

function Bars::Create(%this)
{
	if(isObject(DamageHud) && isObject(EnergyHud) && isObject(HeatHud))
		%this.destroy();
	
	new HudDamage(DamageHud)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = %this.damagex SPC %this.damagey;
		minExtent = %this.damagex SPC %this.damagey;
		visible = "1";
		setFirstResponder = "0";
		modal = "1";
		helpTag = "0";
		fillColor = "0.000 1.000 0.000 0.800000";
		frameColor = "0.000000 1.000000 0.000000 0.000000";
		opacity = "1";
		subRegion = "0 0" SPC %this.damagex SPC %this.damagey;
		pulseRate = "500";
		pulseThreshold = "0.3";
	};
	new HudEnergy(EnergyHud)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 20";
		extent = %this.energyx SPC %this.energyy;
		minExtent = %this.energyx SPC %this.energyy;
		visible = "1";
		setFirstResponder = "0";
		modal = "1";
		helpTag = "0";
		fillColor = "0.353000 0.373000 0.933000 0.800000";
		frameColor = "0.000000 1.000000 0.000000 1.000000";
		opacity = "1";
		subRegion = "0 0" SPC %this.energyx SPC %this.energyy;
		pulseRate = "500";
		pulseThreshold = "0.3";
	};
	new HudHeat(HeatHud)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 40";
		extent = %this.heatx SPC %this.heaty;
		minExtent = %this.heatx SPC %this.heaty;
		visible = "0";
		setFirstResponder = "0";
		modal = "1";
		helpTag = "0";
		fillColor = "1.000 0.000 0.000 0.800000";
		opacity = "1";
		subRegion = "0 0" SPC %this.heatx SPC %this.heaty;
		pulseRate = "500";
		pulseThreshold = "0.3";
		heatWarning = "0.7";
	};
	playGui.add(DamageHud);
   playGui.add(EnergyHud);
   playGui.add(HeatHud);
}

function Bars::Destroy(%this)
{
	if(playGui.isMember(DamageHud)) { playGui.remove(DamageHud); DamageHud.delete(); }
	if(playGui.isMember(EnergyHud)) { playGui.remove(EnergyHud); EnergyHud.delete(); }
	if(playGui.isMember(HeatHud)) { playGui.remove(HeatHud); HeatHud.delete(); }
}
	
