if (!isObject(TimClock))
{
	new ScriptObject(TimClock)
	{
		class = TimClock;
		gui = "TimClockGui";
		time = "TimClockTimeGui";
		fontProfile = "TimClockProfile";
		font = "arial bold";
		fontSize = 13;
		fontColor = "240 240 240";		
	};
}

function TimClock::Position(%this)
{
	%x = getWord($pref::video::resolution, 0) - 60;
	%y = 0;
	%this.gui.position = %x SPC %y;
	%this.positioned = true;
}

package TimClock 
{
	function setSystemClock(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
	{
		$Hud::TimeLimit = detag(%a1);
		%timeLeftMS = detag(%a2);
		TimClock.time.setTime(%timeLeftMS / (60 * 1000));
		parent::setSystemClock(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);
	}
	
	function clientCmdSyncHudClock(%time)
	{
		TimClock.time.setTime(%time);
		parent::clientCmdSyncHudClock(%time);
	}
	
	function DispatchLaunchMode()
	{
		parent::DispatchLaunchMode();
		TimClock.Create();		
	}		
	
	function LoadingGui::onWake(%this)
	{
		if (isObject(HudMover)) hudmover::addhud(TimClock.gui, "TimClock");
		parent::onWake(%this);
	}
	
	//function playGui::onWake(%this)
	//{
	//	parent::onWake(%this);
	//	if(!TimClock.positioned) TimClock.schedule(500, Position);
	//}
	
	function clientCmdTogglePlayHuds(%val)
	{
		parent::clientCmdTogglePlayHuds(%val);
		TimClock.gui.setVisible(%val);
	}

};
activatePackage(TimClock);

function TimClock::Create(%this)
{	
	if(isObject(TimClock.gui))
		TimClock.Destroy();
	
	new GuiControlProfile (%this.fontProfile)
	{
		FontType = %this.font;
		FontSize = %this.fontSize;
		fontColor = %this.fontColor;
		justify = "right";
	};

	new ShellFieldCtrl(%this.gui)
	{
		profile = "GuiConsoleProfile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = "794 865";
		extent = "60 20";
		minExtent = "8 8";
		visible = "1";
		
		new HudClock(%this.time)
		{
			profile = %this.fontProfile;
			horizSizing = "left";
			vertSizing = "bottom";
			position = "1 0";
			extent = "60 20";
			visible = "1";
			bitmap = "gui/hud_mistimer.png";
			subRegion = "0 2 60 19";
			text = "";
		};
	};
	playGui.add(%this.gui);
}

function TimClock::Destroy(%this)
{
		playGui.remove(%this.gui);
		%this.gui.delete();
}
