// #name = pingHud
// #version = 1.1
// #date = 2001-09-27
// #author = Runar
// #credits = Crunchy, who's things i shamelessly copies
// #email = runar@vsdn.org
// #web = http://www.vsdn.org
// #description = Hud that uses the built in netmeter
// #status = Release 2
// #Edited by Anakha 2002-12-21

// exec("scripts/autoexec/pinghud.cs");

if(!isObject(PingHud))
{
	new ScriptObject(PingHud)
	{
		class = PingHud;
		ScheduleId = 0;
		Counter = 0;
		Sum = 0;
		LabelColor = "240 240 240";
		TextColor = "240 240 240";
		Gui = "PingHudGui";
	};
}

function PingHud::Setup(%this)
{
	new GuiControlProfile ("PingHudLabelProfile")
	{
		FontType = "arial bold";
		FontSize = 13;
		fontColor = %this.LabelColor;
		justify = "left";
	};	
	new GuiControlProfile ("PingHudTextProfile")
	{
		FontType = "arial Bold";
		FontSize = 13;
		fontColor = %this.TextColor;
		justify = "left";
	};
}

function PingHud::Create(%this)
{
	%this.Destroy();

	%x = getWord(hudClusterBack.position, 0)-43-8;
	%y = getWord(hudClusterBack.position, 1)+20;
	
	new ShellFieldCtrl(%this.Gui)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = %x SPC %y;
		extent = "100 18";
		minExtent = "8 8";
		visible = "1";
		
		new GuiTextCtrl()
		{
			profile = "PingHudLabelProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "100 18 ";
			visible = "1";
			text = "ping:";
		};
	};

	%this.Gui.text = new GuiTextCtrl() {
		profile = "pingHudTextProfile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = "20 0";
		extent = "100 18 ";
		visible = "1";
	};

	%this.Gui.add(%this.Gui.text);
	playGui.add(%this.Gui);
}

function pingHud::Update(%this, %ping)
{
	if(isObject(%this.Gui))
		%this.Gui.text.setValue(%ping > 999 ? 999 : %ping);
}

function PingHud::Destroy(%this)
{
	if(%this.ScheduleId != 0)
		cancel(%this.ScheduleId);

	if(isObject(%this.Gui))
	{
		playGui.remove(%this.Gui);
		%this.Gui.delete();
	}
}

function PingHud::Calc(%this, %ping)
{
	%this.Sum = %this.Sum + mFormatFloat(%ping, "%4.0f");

	if(%this.Counter++ == 20)
	{
		%this.Update(mFormatFloat(%this.Sum / 20, "%4.0f"));
		%this.Counter = 0;
		%this.Sum = 0;
	}
}

package pingHud
{

	function NetBarHud::infoUpdate(%this, %ping, %packetLoss, %sendPackets, %sendBytes, %receivePackets, %receiveBytes)
	{
		parent::infoUpdate(%this, %ping, %packetLoss, %sendPackets, %sendBytes, %receivePackets, %receiveBytes);

		PingHud.Calc(%ping);
	}

	function clientCmdTogglePlayHuds(%val)
	{
		parent::clientCmdTogglePlayHuds(%val);

		pingHudGui.setVisible(%val);
	}

	function DispatchLaunchMode()
	{
		PingHud.Setup();

		parent::DispatchLaunchMode();
	}

	function LoadingGui::onWake(%this)
	{
		if(!$pingHudCreated)
		{
			pingHud.Create();
	
			if(isObject(HudMover))
				hudmover::addhud(PingHudGui, "PingHud");

			$pingHudCreated = true;
		}
	
		parent::onWake(%this);
	}
};

activatePackage(pingHud);
